// Made with Blockbench 4.11.2
// Exported for Minecraft version 1.17 or later with Mojang mappings
// Paste this class into your mod and generate all required imports

public class ModelRazor_Tyrant<T extends Entity> extends EntityModel<T> {
	// This layer location should be baked with EntityRendererProvider.Context in
	// the entity renderer and passed into this model's constructor
	public static final ModelLayerLocation LAYER_LOCATION = new ModelLayerLocation(
			new ResourceLocation("modid", "razor_tyrant"), "main");
	private final ModelPart whole;
	private final ModelPart lowbody;
	private final ModelPart middlebody;
	private final ModelPart chest;
	private final ModelPart neck;
	private final ModelPart head;
	private final ModelPart armL;
	private final ModelPart upperarmL;
	private final ModelPart lowarmL;
	private final ModelPart armR;
	private final ModelPart upperarmR;
	private final ModelPart lowarmR;
	private final ModelPart rightFirstLeg;
	private final ModelPart rightSecondLeg;
	private final ModelPart rightThirdLeg;
	private final ModelPart rightFoot;
	private final ModelPart leftFirstLeg;
	private final ModelPart leftSecondLeg;
	private final ModelPart leftThirdLeg;
	private final ModelPart leftFoot;

	public ModelRazor_Tyrant(ModelPart root) {
		this.whole = root.getChild("whole");
		this.lowbody = this.whole.getChild("lowbody");
		this.middlebody = this.lowbody.getChild("middlebody");
		this.chest = this.middlebody.getChild("chest");
		this.neck = this.chest.getChild("neck");
		this.head = this.neck.getChild("head");
		this.armL = this.chest.getChild("armL");
		this.upperarmL = this.armL.getChild("upperarmL");
		this.lowarmL = this.upperarmL.getChild("lowarmL");
		this.armR = this.chest.getChild("armR");
		this.upperarmR = this.armR.getChild("upperarmR");
		this.lowarmR = this.upperarmR.getChild("lowarmR");
		this.rightFirstLeg = this.whole.getChild("rightFirstLeg");
		this.rightSecondLeg = this.rightFirstLeg.getChild("rightSecondLeg");
		this.rightThirdLeg = this.rightSecondLeg.getChild("rightThirdLeg");
		this.rightFoot = this.rightThirdLeg.getChild("rightFoot");
		this.leftFirstLeg = this.whole.getChild("leftFirstLeg");
		this.leftSecondLeg = this.leftFirstLeg.getChild("leftSecondLeg");
		this.leftThirdLeg = this.leftSecondLeg.getChild("leftThirdLeg");
		this.leftFoot = this.leftThirdLeg.getChild("leftFoot");
	}

	public static LayerDefinition createBodyLayer() {
		MeshDefinition meshdefinition = new MeshDefinition();
		PartDefinition partdefinition = meshdefinition.getRoot();

		PartDefinition whole = partdefinition.addOrReplaceChild("whole", CubeListBuilder.create(),
				PartPose.offset(0.0F, 24.0F, 0.0F));

		PartDefinition lowbody = whole.addOrReplaceChild("lowbody",
				CubeListBuilder.create().texOffs(66, 0)
						.addBox(-6.5F, -3.0F, -4.0F, 13.0F, 6.0F, 6.0F, new CubeDeformation(0.0F)).texOffs(44, 21)
						.addBox(-1.0F, -8.0F, 1.0F, 2.0F, 2.0F, 3.0F, new CubeDeformation(0.0F)).texOffs(50, 32)
						.addBox(-1.0F, -12.0F, 1.0F, 2.0F, 2.0F, 3.0F, new CubeDeformation(0.0F)).texOffs(97, 99)
						.addBox(-3.5F, -12.0F, -3.0F, 7.0F, 12.0F, 4.0F, new CubeDeformation(0.0F)),
				PartPose.offset(0.0F, -43.0F, 0.0F));

		PartDefinition middlebody = lowbody.addOrReplaceChild("middlebody", CubeListBuilder.create(),
				PartPose.offset(-0.5F, -12.0F, 0.0F));

		PartDefinition cube_r1 = middlebody.addOrReplaceChild("cube_r1",
				CubeListBuilder.create().texOffs(59, 0)
						.addBox(-1.5F, -5.0F, 2.0F, 2.0F, 2.0F, 3.0F, new CubeDeformation(0.0F)).texOffs(45, 71)
						.addBox(-1.5F, -9.0F, 2.0F, 2.0F, 2.0F, 3.0F, new CubeDeformation(0.0F)).texOffs(27, 76)
						.addBox(-1.5F, -13.0F, 2.0F, 2.0F, 2.0F, 3.0F, new CubeDeformation(0.0F)).texOffs(0, 21)
						.addBox(-10.0F, -14.0F, -4.0F, 19.0F, 13.0F, 6.0F, new CubeDeformation(0.0F)),
				PartPose.offsetAndRotation(1.0F, 1.0F, 0.0F, 0.1745F, 0.0F, 0.0F));

		PartDefinition cube_r2 = middlebody.addOrReplaceChild("cube_r2",
				CubeListBuilder.create().texOffs(25, 118)
						.addBox(-9.0F, -19.0F, -4.5F, 2.0F, 13.0F, 3.0F, new CubeDeformation(0.0F)).texOffs(76, 117)
						.addBox(6.0F, -19.0F, -4.5F, 2.0F, 13.0F, 3.0F, new CubeDeformation(0.0F)),
				PartPose.offsetAndRotation(1.0F, 1.0F, 0.0F, 0.2618F, 0.0F, 0.0F));

		PartDefinition chest = middlebody.addOrReplaceChild("chest",
				CubeListBuilder.create().texOffs(26, 40)
						.addBox(13.0F, -12.0F, -6.0F, 4.0F, 5.0F, 3.0F, new CubeDeformation(0.0F)).texOffs(82, 12)
						.addBox(-16.0F, -12.0F, -6.0F, 4.0F, 5.0F, 3.0F, new CubeDeformation(0.0F)),
				PartPose.offset(0.0F, -13.0F, -3.0F));

		PartDefinition cube_r3 = chest.addOrReplaceChild("cube_r3",
				CubeListBuilder.create().texOffs(83, 55)
						.addBox(-1.5F, 1.0F, 4.0F, 2.0F, 2.0F, 3.0F, new CubeDeformation(0.0F)).texOffs(14, 87)
						.addBox(-1.5F, -4.0F, 4.0F, 2.0F, 2.0F, 3.0F, new CubeDeformation(0.0F)).texOffs(97, 85)
						.addBox(-1.5F, -9.0F, 4.0F, 2.0F, 2.0F, 3.0F, new CubeDeformation(0.0F)).texOffs(93, 71)
						.addBox(-14.0F, -10.0F, 4.0F, 4.0F, 4.0F, 10.0F, new CubeDeformation(0.0F)).texOffs(97, 85)
						.addBox(8.0F, -10.0F, 4.0F, 4.0F, 4.0F, 10.0F, new CubeDeformation(0.0F)).texOffs(0, 0)
						.addBox(-14.0F, -10.0F, -3.0F, 26.0F, 14.0F, 7.0F, new CubeDeformation(0.0F)).texOffs(60, 35)
						.addBox(-4.5F, -7.0F, -6.0F, 8.0F, 8.0F, 3.0F, new CubeDeformation(0.0F)),
				PartPose.offsetAndRotation(1.0F, -3.0F, -2.0F, 0.3927F, 0.0F, 0.0F));

		PartDefinition neck = chest.addOrReplaceChild("neck", CubeListBuilder.create().texOffs(68, 35).addBox(-2.0F,
				-2.0F, -14.0F, 4.0F, 3.0F, 15.0F, new CubeDeformation(0.0F)), PartPose.offset(0.5F, -11.0F, -5.0F));

		PartDefinition head = neck.addOrReplaceChild("head",
				CubeListBuilder.create().texOffs(0, 0)
						.addBox(-1.0F, -2.0F, -8.0F, 2.0F, 2.0F, 1.0F, new CubeDeformation(0.0F)).texOffs(91, 43)
						.addBox(-3.0F, -4.0F, -7.0F, 6.0F, 6.0F, 1.0F, new CubeDeformation(0.0F)).texOffs(28, 105)
						.addBox(-3.0F, -4.0F, -5.0F, 6.0F, 7.0F, 6.0F, new CubeDeformation(0.0F)),
				PartPose.offset(0.0F, 0.0F, -13.0F));

		PartDefinition cube_r4 = head.addOrReplaceChild("cube_r4",
				CubeListBuilder.create().texOffs(68, 53).addBox(-0.6194F, -2.0F, 0.0866F, 8.0F, 4.0F, 1.0F,
						new CubeDeformation(0.0F)),
				PartPose.offsetAndRotation(3.0F, 0.0F, -6.0F, 0.0F, -0.4363F, 0.0F));

		PartDefinition cube_r5 = head.addOrReplaceChild("cube_r5",
				CubeListBuilder.create().texOffs(27, 71).addBox(-8.0F, -2.0F, 0.0F, 8.0F, 4.0F, 1.0F,
						new CubeDeformation(0.0F)),
				PartPose.offsetAndRotation(-2.0F, 0.0F, -6.0F, 0.0F, 0.3927F, 0.0F));

		PartDefinition cube_r6 = head.addOrReplaceChild("cube_r6",
				CubeListBuilder.create().texOffs(93, 71).addBox(-2.0F, -9.0F, -0.7F, 4.0F, 9.0F, 1.0F,
						new CubeDeformation(0.0F)),
				PartPose.offsetAndRotation(-2.0F, -2.0F, -5.0F, -0.3832F, 0.2014F, -0.7937F));

		PartDefinition cube_r7 = head.addOrReplaceChild("cube_r7",
				CubeListBuilder.create().texOffs(0, 71).addBox(-2.0F, -9.0F, -1.0F, 4.0F, 9.0F, 1.0F,
						new CubeDeformation(0.0F)),
				PartPose.offsetAndRotation(2.0F, -2.0F, -5.0F, -0.3832F, -0.2014F, 0.7937F));

		PartDefinition cube_r8 = head
				.addOrReplaceChild("cube_r8",
						CubeListBuilder.create().texOffs(119, 112).addBox(-4.0F, -12.0F, -2.0F, 4.0F, 12.0F, 1.0F,
								new CubeDeformation(0.0F)),
						PartPose.offsetAndRotation(2.0F, -2.0F, -5.0F, -0.48F, 0.0F, 0.0F));

		PartDefinition armL = chest.addOrReplaceChild("armL", CubeListBuilder.create(),
				PartPose.offset(17.0F, -9.5F, -4.5F));

		PartDefinition upperarmL = armL.addOrReplaceChild("upperarmL",
				CubeListBuilder.create().texOffs(57, 12)
						.addBox(0.0F, -9.5F, -3.5F, 8.0F, 14.0F, 9.0F, new CubeDeformation(0.0F)).texOffs(114, 60)
						.addBox(2.0F, 4.5F, -1.5F, 4.0F, 16.0F, 2.0F, new CubeDeformation(0.0F)).texOffs(95, 115)
						.addBox(2.0F, 4.5F, 1.5F, 4.0F, 16.0F, 2.0F, new CubeDeformation(0.0F)).texOffs(0, 71)
						.addBox(0.0F, 20.5F, -4.5F, 8.0F, 5.0F, 11.0F, new CubeDeformation(0.0F)),
				PartPose.offset(0.0F, 0.0F, 0.0F));

		PartDefinition lowarmL = upperarmL.addOrReplaceChild("lowarmL",
				CubeListBuilder.create().texOffs(14, 85)
						.addBox(0.0F, 8.5F, -3.5F, 0.0F, 27.0F, 7.0F, new CubeDeformation(0.0F)).texOffs(84, 53)
						.addBox(-3.0F, -0.5F, -4.5F, 6.0F, 9.0F, 9.0F, new CubeDeformation(0.0F)),
				PartPose.offset(4.0F, 26.0F, 1.0F));

		PartDefinition armR = chest.addOrReplaceChild("armR", CubeListBuilder.create(),
				PartPose.offset(-16.0F, -9.5F, -4.5F));

		PartDefinition upperarmR = armR.addOrReplaceChild("upperarmR",
				CubeListBuilder.create().texOffs(59, 62)
						.addBox(-8.0F, -9.5F, -3.5F, 8.0F, 14.0F, 9.0F, new CubeDeformation(0.0F)).texOffs(107, 115)
						.addBox(-6.0F, 4.5F, -1.5F, 4.0F, 16.0F, 2.0F, new CubeDeformation(0.0F)).texOffs(64, 117)
						.addBox(-6.0F, 4.5F, 1.5F, 4.0F, 16.0F, 2.0F, new CubeDeformation(0.0F)).texOffs(27, 76)
						.addBox(-8.0F, 20.5F, -4.5F, 8.0F, 5.0F, 11.0F, new CubeDeformation(0.0F)),
				PartPose.offset(0.0F, 0.0F, 0.0F));

		PartDefinition lowarmR = upperarmR.addOrReplaceChild("lowarmR",
				CubeListBuilder.create().texOffs(0, 80)
						.addBox(0.0F, 9.0F, -3.5F, 0.0F, 27.0F, 7.0F, new CubeDeformation(0.0F)).texOffs(91, 12)
						.addBox(-3.0F, 0.0F, -4.5F, 6.0F, 9.0F, 9.0F, new CubeDeformation(0.0F)),
				PartPose.offset(-4.0F, 25.5F, 1.0F));

		PartDefinition rightFirstLeg = whole.addOrReplaceChild("rightFirstLeg", CubeListBuilder.create().texOffs(34, 40)
				.addBox(-8.0F, -5.0F, -4.0F, 9.0F, 23.0F, 8.0F, new CubeDeformation(0.0F)),
				PartPose.offset(-7.5F, -42.0F, -1.0F));

		PartDefinition rightSecondLeg = rightFirstLeg.addOrReplaceChild("rightSecondLeg", CubeListBuilder.create(),
				PartPose.offset(-3.5F, 17.0F, 0.0F));

		PartDefinition cube_r9 = rightSecondLeg
				.addOrReplaceChild("cube_r9",
						CubeListBuilder.create().texOffs(112, 0).addBox(-2.6F, -1.4415F, -0.9149F, 5.0F, 13.0F, 4.0F,
								new CubeDeformation(0.5F)),
						PartPose.offsetAndRotation(0.0F, 2.0F, 1.0F, 2.1817F, 0.0F, 0.0F));

		PartDefinition rightThirdLeg = rightSecondLeg.addOrReplaceChild("rightThirdLeg", CubeListBuilder.create(),
				PartPose.offset(0.0F, -4.0F, 10.0F));

		PartDefinition cube_r10 = rightThirdLeg.addOrReplaceChild(
				"cube_r10", CubeListBuilder.create().texOffs(81, 85).addBox(-2.5F, -27.3609F, -1.8981F, 5.0F, 29.0F,
						3.0F, new CubeDeformation(1.0F)),
				PartPose.offsetAndRotation(0.0F, 0.0F, 0.0F, 2.8362F, 0.0F, 0.0F));

		PartDefinition rightFoot = rightThirdLeg.addOrReplaceChild("rightFoot", CubeListBuilder.create(),
				PartPose.offset(0.0F, 26.0F, -8.0F));

		PartDefinition cube_r11 = rightFoot.addOrReplaceChild("cube_r11",
				CubeListBuilder.create().texOffs(12, 119)
						.addBox(3.0F, -14.0F, -1.0F, 3.0F, 10.0F, 3.0F, new CubeDeformation(0.0F)).texOffs(0, 114)
						.addBox(-1.0F, -19.0F, -1.0F, 3.0F, 15.0F, 3.0F, new CubeDeformation(0.0F)).texOffs(119, 99)
						.addBox(-5.0F, -14.0F, -1.0F, 3.0F, 10.0F, 3.0F, new CubeDeformation(0.0F)).texOffs(28, 92)
						.addBox(-6.0F, -4.0F, -1.0F, 13.0F, 9.0F, 4.0F, new CubeDeformation(0.0F)),
				PartPose.offsetAndRotation(-0.5F, 2.0F, -1.0F, 1.5708F, 0.0F, 0.0F));

		PartDefinition leftFirstLeg = whole.addOrReplaceChild("leftFirstLeg", CubeListBuilder.create().texOffs(0, 40)
				.addBox(-1.0F, -5.0F, -4.0F, 9.0F, 23.0F, 8.0F, new CubeDeformation(0.0F)),
				PartPose.offset(7.5F, -42.0F, -1.0F));

		PartDefinition leftSecondLeg = leftFirstLeg.addOrReplaceChild("leftSecondLeg", CubeListBuilder.create(),
				PartPose.offset(3.5F, 17.0F, 0.0F));

		PartDefinition cube_r12 = leftSecondLeg.addOrReplaceChild(
				"cube_r12", CubeListBuilder.create().texOffs(106, 43).addBox(-2.4F, -1.4415F, -0.9149F, 5.0F, 13.0F,
						4.0F, new CubeDeformation(0.5F)),
				PartPose.offsetAndRotation(0.0F, 2.0F, 1.0F, 2.1817F, 0.0F, 0.0F));

		PartDefinition leftThirdLeg = leftSecondLeg.addOrReplaceChild("leftThirdLeg", CubeListBuilder.create(),
				PartPose.offset(0.0F, -4.0F, 10.0F));

		PartDefinition cube_r13 = leftThirdLeg.addOrReplaceChild(
				"cube_r13", CubeListBuilder.create().texOffs(65, 85).addBox(-2.5F, -27.3609F, -1.8981F, 5.0F, 29.0F,
						3.0F, new CubeDeformation(1.0F)),
				PartPose.offsetAndRotation(0.0F, 0.0F, 0.0F, 2.8362F, 0.0F, 0.0F));

		PartDefinition leftFoot = leftThirdLeg.addOrReplaceChild("leftFoot", CubeListBuilder.create(),
				PartPose.offset(0.0F, 26.0F, -8.0F));

		PartDefinition cube_r14 = leftFoot.addOrReplaceChild("cube_r14",
				CubeListBuilder.create().texOffs(35, 118)
						.addBox(-6.0F, -14.0F, -1.0F, 3.0F, 10.0F, 3.0F, new CubeDeformation(0.0F)).texOffs(52, 105)
						.addBox(-2.0F, -19.0F, -1.0F, 3.0F, 15.0F, 3.0F, new CubeDeformation(0.0F)).texOffs(118, 82)
						.addBox(2.0F, -14.0F, -1.0F, 3.0F, 10.0F, 3.0F, new CubeDeformation(0.0F)).texOffs(91, 30)
						.addBox(-7.0F, -4.0F, -1.0F, 13.0F, 9.0F, 4.0F, new CubeDeformation(0.0F)),
				PartPose.offsetAndRotation(0.5F, 2.0F, -1.0F, 1.5708F, 0.0F, 0.0F));

		return LayerDefinition.create(meshdefinition, 256, 256);
	}

	@Override
	public void renderToBuffer(PoseStack poseStack, VertexConsumer vertexConsumer, int packedLight, int packedOverlay,
			float red, float green, float blue, float alpha) {
		whole.render(poseStack, vertexConsumer, packedLight, packedOverlay, red, green, blue, alpha);
	}

	public void setupAnim(T entity, float limbSwing, float limbSwingAmount, float ageInTicks, float netHeadYaw,
			float headPitch) {
		this.neck.yRot = netHeadYaw / (180F / (float) Math.PI);
		this.neck.xRot = headPitch / (180F / (float) Math.PI);
	}
}