
/*
 *    MCreator note: This file will be REGENERATED on each build.
 */
package net.mcreator.razortyrant.init;

import net.minecraftforge.registries.RegistryObject;
import net.minecraftforge.registries.ForgeRegistries;
import net.minecraftforge.registries.DeferredRegister;
import net.minecraftforge.fml.event.lifecycle.FMLCommonSetupEvent;
import net.minecraftforge.fml.common.Mod;
import net.minecraftforge.eventbus.api.SubscribeEvent;
import net.minecraftforge.event.entity.EntityAttributeCreationEvent;

import net.minecraft.world.entity.MobCategory;
import net.minecraft.world.entity.EntityType;
import net.minecraft.world.entity.Entity;

import net.mcreator.razortyrant.entity.TyrantProjectileEntity;
import net.mcreator.razortyrant.entity.RazorTyrantEntity;
import net.mcreator.razortyrant.RazorTyrantMod;

@Mod.EventBusSubscriber(bus = Mod.EventBusSubscriber.Bus.MOD)
public class RazorTyrantModEntities {
	public static final DeferredRegister<EntityType<?>> REGISTRY = DeferredRegister.create(ForgeRegistries.ENTITY_TYPES, RazorTyrantMod.MODID);
	public static final RegistryObject<EntityType<RazorTyrantEntity>> RAZOR_TYRANT = register("razor_tyrant", EntityType.Builder.<RazorTyrantEntity>of(RazorTyrantEntity::new, MobCategory.MONSTER).setShouldReceiveVelocityUpdates(true)
			.setTrackingRange(64).setUpdateInterval(3).setCustomClientFactory(RazorTyrantEntity::new).fireImmune().sized(2f, 5.5f));
	public static final RegistryObject<EntityType<TyrantProjectileEntity>> TYRANT_PROJECTILE = register("tyrant_projectile", EntityType.Builder.<TyrantProjectileEntity>of(TyrantProjectileEntity::new, MobCategory.MISC)
			.setCustomClientFactory(TyrantProjectileEntity::new).setShouldReceiveVelocityUpdates(true).setTrackingRange(64).setUpdateInterval(1).sized(0.5f, 0.5f));

	// Start of user code block custom entities
	// End of user code block custom entities
	private static <T extends Entity> RegistryObject<EntityType<T>> register(String registryname, EntityType.Builder<T> entityTypeBuilder) {
		return REGISTRY.register(registryname, () -> (EntityType<T>) entityTypeBuilder.build(registryname));
	}

	@SubscribeEvent
	public static void init(FMLCommonSetupEvent event) {
		event.enqueueWork(() -> {
			RazorTyrantEntity.init();
		});
	}

	@SubscribeEvent
	public static void registerAttributes(EntityAttributeCreationEvent event) {
		event.put(RAZOR_TYRANT.get(), RazorTyrantEntity.createAttributes().build());
	}
}
