package net.mcreator.razortyrant.procedures;

import net.minecraft.world.phys.Vec3;
import net.minecraft.world.phys.AABB;
import net.minecraft.world.level.LevelAccessor;
import net.minecraft.world.entity.player.Player;
import net.minecraft.util.RandomSource;
import net.minecraft.util.Mth;

import net.mcreator.razortyrant.configuration.RazorTyrantModConfigConfiguration;

public class RazorTyrantNaturalEntitySpawningConditionProcedure {
	public static boolean execute(LevelAccessor world, double x, double y, double z) {
		double spawnRate = 0;
		if (RazorTyrantModConfigConfiguration.ISSPAWNNATURALLY.get()) {
			spawnRate = Math.max(1, (double) RazorTyrantModConfigConfiguration.SPAWNRATE.get());
			return Mth.nextInt(RandomSource.create(), 1, (int) spawnRate) == 1 && !world.getEntitiesOfClass(Player.class, AABB.ofSize(new Vec3(x, y, z), 80, 80, 80), e -> true).isEmpty();
		}
		return false;
	}
}
