
package net.mcreator.razortyrant.entity;

import net.minecraftforge.registries.ForgeRegistries;
import net.minecraftforge.network.PlayMessages;
import net.minecraftforge.network.NetworkHooks;

import net.minecraft.world.level.pathfinder.BlockPathTypes;
import net.minecraft.world.level.levelgen.Heightmap;
import net.minecraft.world.level.block.state.BlockState;
import net.minecraft.world.level.ServerLevelAccessor;
import net.minecraft.world.level.LevelReader;
import net.minecraft.world.level.Level;
import net.minecraft.world.entity.player.Player;
import net.minecraft.world.entity.monster.Monster;
import net.minecraft.world.entity.ai.navigation.PathNavigation;
import net.minecraft.world.entity.ai.goal.target.NearestAttackableTargetGoal;
import net.minecraft.world.entity.ai.goal.target.HurtByTargetGoal;
import net.minecraft.world.entity.ai.goal.RandomStrollGoal;
import net.minecraft.world.entity.ai.goal.RandomLookAroundGoal;
import net.minecraft.world.entity.ai.goal.MeleeAttackGoal;
import net.minecraft.world.entity.ai.goal.FloatGoal;
import net.minecraft.world.entity.ai.attributes.Attributes;
import net.minecraft.world.entity.ai.attributes.AttributeSupplier;
import net.minecraft.world.entity.SpawnPlacements;
import net.minecraft.world.entity.SpawnGroupData;
import net.minecraft.world.entity.MobType;
import net.minecraft.world.entity.MobSpawnType;
import net.minecraft.world.entity.Mob;
import net.minecraft.world.entity.LivingEntity;
import net.minecraft.world.entity.EntityType;
import net.minecraft.world.entity.Entity;
import net.minecraft.world.entity.AnimationState;
import net.minecraft.world.damagesource.DamageTypes;
import net.minecraft.world.damagesource.DamageSource;
import net.minecraft.world.DifficultyInstance;
import net.minecraft.sounds.SoundEvent;
import net.minecraft.resources.ResourceLocation;
import net.minecraft.network.syncher.SynchedEntityData;
import net.minecraft.network.syncher.EntityDataSerializers;
import net.minecraft.network.syncher.EntityDataAccessor;
import net.minecraft.network.protocol.game.ClientGamePacketListener;
import net.minecraft.network.protocol.Packet;
import net.minecraft.nbt.CompoundTag;
import net.minecraft.core.BlockPos;

import net.mcreator.razortyrant.procedures.RazorTyrantWalkPlaybackConditionProcedure;
import net.mcreator.razortyrant.procedures.RazorTyrantRightUpStabPlayBackConditionProcedure;
import net.mcreator.razortyrant.procedures.RazorTyrantRightStompPlaybackConditionProcedure;
import net.mcreator.razortyrant.procedures.RazorTyrantRightSlashPlaybackConditionProcedure;
import net.mcreator.razortyrant.procedures.RazorTyrantRightLowStabPlayBackConditionProcedure;
import net.mcreator.razortyrant.procedures.RazorTyrantRightChoppingPlaybackConditionProcedure;
import net.mcreator.razortyrant.procedures.RazorTyrantOnInitialEntitySpawnProcedure;
import net.mcreator.razortyrant.procedures.RazorTyrantOnEntityTickUpdateProcedure;
import net.mcreator.razortyrant.procedures.RazorTyrantNaturalEntitySpawningConditionProcedure;
import net.mcreator.razortyrant.procedures.RazorTyrantLeftUpStabPlayBackConditionProcedure;
import net.mcreator.razortyrant.procedures.RazorTyrantLeftSlashPlaybackConditionProcedure;
import net.mcreator.razortyrant.procedures.RazorTyrantLeftLowStabPlayBackConditionProcedure;
import net.mcreator.razortyrant.procedures.RazorTyrantLeftChoppingPlaybackConditionProcedure;
import net.mcreator.razortyrant.procedures.RazorTyrantLeapPlaybackConditionProcedure;
import net.mcreator.razortyrant.procedures.RazorTyrantHeadShootPlaybackConditionProcedure;
import net.mcreator.razortyrant.procedures.RazorTyrantFirstEncounterPlaybackConditionProcedure;
import net.mcreator.razortyrant.init.RazorTyrantModEntities;
import net.mcreator.razortyrant.SlowRotMoveControl;
import net.mcreator.razortyrant.GroundPathNavigatorNoSpin;

import javax.annotation.Nullable;

public class RazorTyrantEntity extends Monster {
	public static final EntityDataAccessor<Integer> DATA_ActionState = SynchedEntityData.defineId(RazorTyrantEntity.class, EntityDataSerializers.INT);
	public static final EntityDataAccessor<Integer> DATA_RightArmActionState = SynchedEntityData.defineId(RazorTyrantEntity.class, EntityDataSerializers.INT);
	public static final EntityDataAccessor<Integer> DATA_LeftArmActionState = SynchedEntityData.defineId(RazorTyrantEntity.class, EntityDataSerializers.INT);
	public final AnimationState animationState0 = new AnimationState();
	public final AnimationState animationState2 = new AnimationState();
	public final AnimationState animationState3 = new AnimationState();
	public final AnimationState animationState4 = new AnimationState();
	public final AnimationState animationState5 = new AnimationState();
	public final AnimationState animationState6 = new AnimationState();
	public final AnimationState animationState7 = new AnimationState();
	public final AnimationState animationState8 = new AnimationState();
	public final AnimationState animationState9 = new AnimationState();
	public final AnimationState animationState10 = new AnimationState();
	public final AnimationState animationState11 = new AnimationState();
	public final AnimationState animationState12 = new AnimationState();
	public final AnimationState animationState13 = new AnimationState();

	public RazorTyrantEntity(PlayMessages.SpawnEntity packet, Level world) {
		this(RazorTyrantModEntities.RAZOR_TYRANT.get(), world);
	}

	public RazorTyrantEntity(EntityType<RazorTyrantEntity> type, Level world) {
		super(type, world);
		setMaxUpStep(2f);
		xpReward = 1800;
		setNoAi(false);
		setPersistenceRequired();
		moveControl = new SlowRotMoveControl(this);
		this.setPathfindingMalus(BlockPathTypes.LEAVES, 0.0F);
		this.setPathfindingMalus(BlockPathTypes.FENCE, 0.0F);
		this.setPathfindingMalus(BlockPathTypes.RAIL, 0.0F);
		this.setPathfindingMalus(BlockPathTypes.UNPASSABLE_RAIL, 0.0F);
		this.setPathfindingMalus(BlockPathTypes.DANGER_FIRE, 0.0F);
		this.setPathfindingMalus(BlockPathTypes.DAMAGE_FIRE, 0.0F);
	}

	public float getWalkTargetValue(BlockPos p_27573_, LevelReader p_27574_) {
		return 10;
	}

	protected PathNavigation createNavigation(Level p21480) {
		return new GroundPathNavigatorNoSpin(this, p21480);
	}

	@Override
	public Packet<ClientGamePacketListener> getAddEntityPacket() {
		return NetworkHooks.getEntitySpawningPacket(this);
	}

	@Override
	protected void defineSynchedData() {
		super.defineSynchedData();
		this.entityData.define(DATA_ActionState, 1073741824);
		this.entityData.define(DATA_RightArmActionState, 0);
		this.entityData.define(DATA_LeftArmActionState, 0);
	}

	@Override
	protected void registerGoals() {
		super.registerGoals();
		this.goalSelector.addGoal(1, new MeleeAttackGoal(this, 1, false) {
			@Override
			protected double getAttackReachSqr(LivingEntity entity) {
				return 0;
			}

			@Override
			public boolean canUse() {
				double x = RazorTyrantEntity.this.getX();
				double y = RazorTyrantEntity.this.getY();
				double z = RazorTyrantEntity.this.getZ();
				Entity entity = RazorTyrantEntity.this;
				Level world = RazorTyrantEntity.this.level();
				return super.canUse() && RazorTyrantWalkPlaybackConditionProcedure.execute(entity);
			}

			@Override
			public boolean canContinueToUse() {
				double x = RazorTyrantEntity.this.getX();
				double y = RazorTyrantEntity.this.getY();
				double z = RazorTyrantEntity.this.getZ();
				Entity entity = RazorTyrantEntity.this;
				Level world = RazorTyrantEntity.this.level();
				return super.canContinueToUse() && RazorTyrantWalkPlaybackConditionProcedure.execute(entity);
			}
		});
		this.goalSelector.addGoal(2, new RandomStrollGoal(this, 1) {
			@Override
			public boolean canUse() {
				double x = RazorTyrantEntity.this.getX();
				double y = RazorTyrantEntity.this.getY();
				double z = RazorTyrantEntity.this.getZ();
				Entity entity = RazorTyrantEntity.this;
				Level world = RazorTyrantEntity.this.level();
				return super.canUse() && RazorTyrantWalkPlaybackConditionProcedure.execute(entity);
			}

			@Override
			public boolean canContinueToUse() {
				double x = RazorTyrantEntity.this.getX();
				double y = RazorTyrantEntity.this.getY();
				double z = RazorTyrantEntity.this.getZ();
				Entity entity = RazorTyrantEntity.this;
				Level world = RazorTyrantEntity.this.level();
				return super.canContinueToUse() && RazorTyrantWalkPlaybackConditionProcedure.execute(entity);
			}
		});
		this.targetSelector.addGoal(3, new HurtByTargetGoal(this));
		this.targetSelector.addGoal(4, new NearestAttackableTargetGoal(this, Player.class, false, false));
		this.targetSelector.addGoal(5, new NearestAttackableTargetGoal(this, Mob.class, false, false));
		this.goalSelector.addGoal(6, new RandomLookAroundGoal(this) {
			@Override
			public boolean canUse() {
				double x = RazorTyrantEntity.this.getX();
				double y = RazorTyrantEntity.this.getY();
				double z = RazorTyrantEntity.this.getZ();
				Entity entity = RazorTyrantEntity.this;
				Level world = RazorTyrantEntity.this.level();
				return super.canUse() && RazorTyrantWalkPlaybackConditionProcedure.execute(entity);
			}

			@Override
			public boolean canContinueToUse() {
				double x = RazorTyrantEntity.this.getX();
				double y = RazorTyrantEntity.this.getY();
				double z = RazorTyrantEntity.this.getZ();
				Entity entity = RazorTyrantEntity.this;
				Level world = RazorTyrantEntity.this.level();
				return super.canContinueToUse() && RazorTyrantWalkPlaybackConditionProcedure.execute(entity);
			}
		});
		this.goalSelector.addGoal(7, new FloatGoal(this));
	}

	@Override
	public MobType getMobType() {
		return MobType.UNDEFINED;
	}

	@Override
	public boolean removeWhenFarAway(double distanceToClosestPlayer) {
		return false;
	}

	@Override
	public void playStepSound(BlockPos pos, BlockState blockIn) {
		this.playSound(ForgeRegistries.SOUND_EVENTS.getValue(new ResourceLocation("entity.iron_golem.step")), 0.15f, 1);
	}

	@Override
	public SoundEvent getHurtSound(DamageSource ds) {
		return ForgeRegistries.SOUND_EVENTS.getValue(new ResourceLocation("entity.iron_golem.hurt"));
	}

	@Override
	public SoundEvent getDeathSound() {
		return ForgeRegistries.SOUND_EVENTS.getValue(new ResourceLocation("entity.iron_golem.death"));
	}

	@Override
	public boolean hurt(DamageSource damagesource, float amount) {
		if (damagesource.is(DamageTypes.IN_FIRE))
			return false;
		if (damagesource.is(DamageTypes.FALL))
			return false;
		if (damagesource.is(DamageTypes.DROWN))
			return false;
		return super.hurt(damagesource, amount);
	}

	@Override
	public boolean fireImmune() {
		return true;
	}

	@Override
	public SpawnGroupData finalizeSpawn(ServerLevelAccessor world, DifficultyInstance difficulty, MobSpawnType reason, @Nullable SpawnGroupData livingdata, @Nullable CompoundTag tag) {
		SpawnGroupData retval = super.finalizeSpawn(world, difficulty, reason, livingdata, tag);
		RazorTyrantOnInitialEntitySpawnProcedure.execute(world, this.getX(), this.getY(), this.getZ(), this);
		return retval;
	}

	@Override
	public void addAdditionalSaveData(CompoundTag compound) {
		super.addAdditionalSaveData(compound);
		compound.putInt("DataActionState", this.entityData.get(DATA_ActionState));
		compound.putInt("DataRightArmActionState", this.entityData.get(DATA_RightArmActionState));
		compound.putInt("DataLeftArmActionState", this.entityData.get(DATA_LeftArmActionState));
	}

	@Override
	public void readAdditionalSaveData(CompoundTag compound) {
		super.readAdditionalSaveData(compound);
		if (compound.contains("DataActionState"))
			this.entityData.set(DATA_ActionState, compound.getInt("DataActionState"));
		if (compound.contains("DataRightArmActionState"))
			this.entityData.set(DATA_RightArmActionState, compound.getInt("DataRightArmActionState"));
		if (compound.contains("DataLeftArmActionState"))
			this.entityData.set(DATA_LeftArmActionState, compound.getInt("DataLeftArmActionState"));
	}

	@Override
	public void tick() {
		super.tick();
		if (this.level().isClientSide()) {
			this.animationState0.animateWhen(true, this.tickCount);
			this.animationState2.animateWhen(RazorTyrantRightStompPlaybackConditionProcedure.execute(this), this.tickCount);
			this.animationState3.animateWhen(RazorTyrantRightSlashPlaybackConditionProcedure.execute(this), this.tickCount);
			this.animationState4.animateWhen(RazorTyrantLeftSlashPlaybackConditionProcedure.execute(this), this.tickCount);
			this.animationState5.animateWhen(RazorTyrantRightChoppingPlaybackConditionProcedure.execute(this), this.tickCount);
			this.animationState6.animateWhen(RazorTyrantLeftChoppingPlaybackConditionProcedure.execute(this), this.tickCount);
			this.animationState7.animateWhen(RazorTyrantHeadShootPlaybackConditionProcedure.execute(this), this.tickCount);
			this.animationState8.animateWhen(RazorTyrantRightLowStabPlayBackConditionProcedure.execute(this), this.tickCount);
			this.animationState9.animateWhen(RazorTyrantLeftLowStabPlayBackConditionProcedure.execute(this), this.tickCount);
			this.animationState10.animateWhen(RazorTyrantRightUpStabPlayBackConditionProcedure.execute(this), this.tickCount);
			this.animationState11.animateWhen(RazorTyrantLeftUpStabPlayBackConditionProcedure.execute(this), this.tickCount);
			this.animationState12.animateWhen(RazorTyrantLeapPlaybackConditionProcedure.execute(this), this.tickCount);
			this.animationState13.animateWhen(RazorTyrantFirstEncounterPlaybackConditionProcedure.execute(this), this.tickCount);
		}
	}

	@Override
	public void baseTick() {
		super.baseTick();
		RazorTyrantOnEntityTickUpdateProcedure.execute(this.level(), this.getX(), this.getY(), this.getZ(), this);
	}

	@Override
	public boolean canBreatheUnderwater() {
		double x = this.getX();
		double y = this.getY();
		double z = this.getZ();
		Level world = this.level();
		Entity entity = this;
		return true;
	}

	public static void init() {
		SpawnPlacements.register(RazorTyrantModEntities.RAZOR_TYRANT.get(), SpawnPlacements.Type.ON_GROUND, Heightmap.Types.MOTION_BLOCKING_NO_LEAVES, (entityType, world, reason, pos, random) -> {
			int x = pos.getX();
			int y = pos.getY();
			int z = pos.getZ();
			return RazorTyrantNaturalEntitySpawningConditionProcedure.execute(world, x, y, z);
		});
	}

	public static AttributeSupplier.Builder createAttributes() {
		AttributeSupplier.Builder builder = Mob.createMobAttributes();
		builder = builder.add(Attributes.MOVEMENT_SPEED, 0.3);
		builder = builder.add(Attributes.MAX_HEALTH, 600);
		builder = builder.add(Attributes.ARMOR, 15);
		builder = builder.add(Attributes.ATTACK_DAMAGE, 10);
		builder = builder.add(Attributes.FOLLOW_RANGE, 64);
		builder = builder.add(Attributes.KNOCKBACK_RESISTANCE, 0.7);
		builder = builder.add(Attributes.ATTACK_KNOCKBACK, 1);
		return builder;
	}
}
