package net.mcreator.razortyrant.procedures;

import net.minecraftforge.registries.ForgeRegistries;

import net.minecraft.world.phys.AABB;
import net.minecraft.world.level.block.LiquidBlock;
import net.minecraft.world.level.block.Block;
import net.minecraft.world.level.LevelAccessor;
import net.minecraft.world.level.Level;
import net.minecraft.world.level.GameRules;
import net.minecraft.world.entity.ai.attributes.Attributes;
import net.minecraft.world.entity.LivingEntity;
import net.minecraft.world.entity.Entity;
import net.minecraft.world.damagesource.DamageTypes;
import net.minecraft.world.damagesource.DamageSource;
import net.minecraft.sounds.SoundSource;
import net.minecraft.resources.ResourceLocation;
import net.minecraft.core.registries.Registries;
import net.minecraft.core.BlockPos;

public class BasicLeftAttackProgressProcedure {
	public static void execute(LevelAccessor world, double x, double y, double z, Entity entity, double attackEndTime, double attackOccurTime, double attacktype, double distance, double width, double yEnd, double yStart, double yawInput,
			String progress, String ticks) {
		if (entity == null || progress == null || ticks == null)
			return;
		double modX = 0;
		double inputc = 0;
		double inputb = 0;
		double inputa = 0;
		double modZ = 0;
		double hardness = 0;
		entity.getPersistentData().putDouble(ticks, (entity.getPersistentData().getDouble(ticks) + 1));
		if (entity.getPersistentData().getDouble(ticks) > attackOccurTime && entity.getPersistentData().getDouble(progress) == 0) {
			entity.getPersistentData().putDouble(progress, 1);
			modX = x + CalculateViewVectorXProcedure.execute(yawInput) * distance;
			modZ = z + CalculateViewVectorZProcedure.execute(yawInput) * distance;
			entity.push((CalculateViewVectorXProcedure.execute(yawInput) * 0.3), 0, (CalculateViewVectorZProcedure.execute(yawInput) * 0.3));
			if (world instanceof Level _level) {
				if (!_level.isClientSide()) {
					_level.playSound(null, BlockPos.containing(modX, y + yStart, modZ), ForgeRegistries.SOUND_EVENTS.getValue(new ResourceLocation("item.trident.throw")), SoundSource.HOSTILE, (float) 1.5, (float) 0.5);
				} else {
					_level.playLocalSound(modX, (y + yStart), modZ, ForgeRegistries.SOUND_EVENTS.getValue(new ResourceLocation("item.trident.throw")), SoundSource.HOSTILE, (float) 1.5, (float) 0.5, false);
				}
			}
			for (Entity entityiterator : world.getEntities(entity, new AABB((modX + width * 0.5), (y + yStart), (modZ + width * 0.5), (modX - width * 0.5), (y + yEnd), (modZ - width * 0.5)))) {
				entityiterator.invulnerableTime = 0;
				entityiterator.hurt(new DamageSource(world.registryAccess().registryOrThrow(Registries.DAMAGE_TYPE).getHolderOrThrow(DamageTypes.MOB_ATTACK), entity),
						(float) (entity instanceof LivingEntity _livingEntity7 && _livingEntity7.getAttributes().hasAttribute(Attributes.ATTACK_DAMAGE) ? _livingEntity7.getAttribute(Attributes.ATTACK_DAMAGE).getValue() : 0));
			}
			if (world.getLevelData().getGameRules().getBoolean(GameRules.RULE_MOBGRIEFING)) {
				modX = Math.floor(modX);
				modZ = Math.floor(modZ);
				inputa = width * (-1);
				while (inputa <= width) {
					inputb = 0;
					while (inputb <= (yEnd - yStart) * 1.5) {
						inputc = width * (-1);
						while (inputc <= width) {
							if (!(world.isEmptyBlock(BlockPos.containing(modX + inputa, y + inputb, modZ + inputc)) || (world.getBlockState(BlockPos.containing(modX + inputa, y + inputb, modZ + inputc))).getBlock() instanceof LiquidBlock)) {
								hardness = world.getBlockState(BlockPos.containing(modX + inputa, y + inputb, modZ + inputc)).getDestroySpeed(world, BlockPos.containing(modX + inputa, y + inputb, modZ + inputc));
								if (hardness > 0 && Math.random() * hardness < 0.9) {
									{
										BlockPos _pos = BlockPos.containing(modX + inputa, y + inputb, modZ + inputc);
										Block.dropResources(world.getBlockState(_pos), world, BlockPos.containing(modX + inputa, y + inputb, modZ + inputc), null);
										world.destroyBlock(_pos, false);
									}
								}
							}
							inputc = inputc + 1;
						}
						inputb = inputb + 1;
					}
					inputa = inputa + 1;
				}
			}
		} else if (entity.getPersistentData().getDouble(ticks) > attackEndTime && entity.getPersistentData().getDouble(progress) == 1) {
			entity.getPersistentData().putDouble(ticks, 0);
			entity.getPersistentData().putDouble(progress, 0);
			SetLeftArmActionStateFalseProcedure.execute(entity, attacktype);
		}
	}
}
