package net.mcreator.razortyrant.procedures;

import net.minecraftforge.registries.ForgeRegistries;

import net.minecraft.world.phys.AABB;
import net.minecraft.world.level.LevelAccessor;
import net.minecraft.world.level.Level;
import net.minecraft.world.entity.ai.attributes.Attributes;
import net.minecraft.world.entity.LivingEntity;
import net.minecraft.world.entity.Entity;
import net.minecraft.world.damagesource.DamageTypes;
import net.minecraft.world.damagesource.DamageSource;
import net.minecraft.sounds.SoundSource;
import net.minecraft.resources.ResourceLocation;
import net.minecraft.core.registries.Registries;
import net.minecraft.core.BlockPos;

import net.mcreator.razortyrant.entity.RazorTyrantEntity;

public class RazorTyrantActionProgressProcedure {
	public static void execute(LevelAccessor world, double x, double y, double z, Entity entity) {
		if (entity == null)
			return;
		double width = 0;
		if ((entity instanceof RazorTyrantEntity _datEntI ? _datEntI.getEntityData().get(RazorTyrantEntity.DATA_ActionState) : 0) != 0) {
			if (RazorTyrantRightStompPlaybackConditionProcedure.execute(entity)) {
				entity.getPersistentData().putDouble("legTicks", (entity.getPersistentData().getDouble("legTicks") + 1));
				if (entity.getPersistentData().getDouble("legTicks") > 13 && entity.getPersistentData().getDouble("legActionProgress") == 0) {
					entity.getPersistentData().putDouble("legActionProgress", 1);
					if (world instanceof Level _level) {
						if (!_level.isClientSide()) {
							_level.playSound(null, BlockPos.containing(x, y, z), ForgeRegistries.SOUND_EVENTS.getValue(new ResourceLocation("entity.player.attack.strong")), SoundSource.HOSTILE, (float) 1.5, 1);
						} else {
							_level.playLocalSound(x, y, z, ForgeRegistries.SOUND_EVENTS.getValue(new ResourceLocation("entity.player.attack.strong")), SoundSource.HOSTILE, (float) 1.5, 1, false);
						}
					}
					width = entity.getBbWidth();
					for (Entity entityiterator : world.getEntities(entity,
							new AABB((x + CalculateViewVectorXProcedure.execute(entity.getYRot()) * width + width * 0.5), (y - width * 0.3), (z + CalculateViewVectorZProcedure.execute(entity.getYRot()) * width + width * 0.5),
									((x + CalculateViewVectorXProcedure.execute(entity.getYRot()) * width) - width * 0.5), (y + width * 0.5), ((z + CalculateViewVectorZProcedure.execute(entity.getYRot()) * width) - width * 0.5)))) {
						entityiterator.invulnerableTime = 0;
						entityiterator.push(0, (-1), 0);
						entityiterator.hurt(new DamageSource(world.registryAccess().registryOrThrow(Registries.DAMAGE_TYPE).getHolderOrThrow(DamageTypes.MOB_ATTACK), entity),
								(float) (entity instanceof LivingEntity _livingEntity13 && _livingEntity13.getAttributes().hasAttribute(Attributes.ATTACK_DAMAGE) ? _livingEntity13.getAttribute(Attributes.ATTACK_DAMAGE).getValue() : 0));
					}
				} else if (entity.getPersistentData().getDouble("legTicks") > 14 && entity.getPersistentData().getDouble("legActionProgress") == 1) {
					entity.getPersistentData().putDouble("legActionProgress", 2);
					if (entity.onGround()) {
						if (world instanceof Level _level) {
							if (!_level.isClientSide()) {
								_level.playSound(null, BlockPos.containing(x, y, z), ForgeRegistries.SOUND_EVENTS.getValue(new ResourceLocation("entity.generic.explode")), SoundSource.HOSTILE, (float) 1.5, 2);
							} else {
								_level.playLocalSound(x, y, z, ForgeRegistries.SOUND_EVENTS.getValue(new ResourceLocation("entity.generic.explode")), SoundSource.HOSTILE, (float) 1.5, 2, false);
							}
						}
						width = entity.getBbWidth();
						for (Entity entityiterator : world.getEntities(entity,
								new AABB((x + CalculateViewVectorXProcedure.execute(entity.getYRot()) * width + width * 3), (y - width), (z + CalculateViewVectorZProcedure.execute(entity.getYRot()) * width + width * 3),
										((x + CalculateViewVectorXProcedure.execute(entity.getYRot()) * width) - width * 3), (y + width), ((z + CalculateViewVectorZProcedure.execute(entity.getYRot()) * width) - width * 3)))) {
							if (entityiterator.onGround()) {
								entityiterator.invulnerableTime = 0;
								entityiterator.hurt(new DamageSource(world.registryAccess().registryOrThrow(Registries.DAMAGE_TYPE).getHolderOrThrow(DamageTypes.MOB_ATTACK), entity),
										(float) ((entity instanceof LivingEntity _livingEntity28 && _livingEntity28.getAttributes().hasAttribute(Attributes.ATTACK_DAMAGE) ? _livingEntity28.getAttribute(Attributes.ATTACK_DAMAGE).getValue() : 0)
												* 0.3));
								entityiterator.push(0, (entity instanceof LivingEntity _livingEntity31 && _livingEntity31.getAttributes().hasAttribute(Attributes.KNOCKBACK_RESISTANCE)
										? (entity instanceof LivingEntity _livingEntity32 && _livingEntity32.getAttributes().hasAttribute(Attributes.ATTACK_KNOCKBACK) ? _livingEntity32.getAttribute(Attributes.ATTACK_KNOCKBACK).getValue() : 0) * 0.4
												* (1.5 - (entityiterator instanceof LivingEntity _livingEntity33 && _livingEntity33.getAttributes().hasAttribute(Attributes.KNOCKBACK_RESISTANCE)
														? _livingEntity33.getAttribute(Attributes.KNOCKBACK_RESISTANCE).getValue()
														: 0))
										: (entity instanceof LivingEntity _livingEntity34 && _livingEntity34.getAttributes().hasAttribute(Attributes.ATTACK_KNOCKBACK) ? _livingEntity34.getAttribute(Attributes.ATTACK_KNOCKBACK).getValue() : 0) * 0.5),
										0);
							}
						}
					}
				} else if (entity.getPersistentData().getDouble("legTicks") > 27 && entity.getPersistentData().getDouble("legActionProgress") == 2) {
					entity.getPersistentData().putDouble("legTicks", 0);
					entity.getPersistentData().putDouble("legActionProgress", 0);
					SetActionStateFalseProcedure.execute(entity, 0);
				}
			}
			if (RazorTyrantHeadShootPlaybackConditionProcedure.execute(entity)) {
				entity.getPersistentData().putDouble("headTicks", (entity.getPersistentData().getDouble("headTicks") + 1));
				if (entity.getPersistentData().getDouble("headTicks") > 9) {
					entity.getPersistentData().putDouble("headTicks", 0);
					SetActionStateFalseProcedure.execute(entity, 1);
				}
			}
			if (RazorTyrantLeapPlaybackConditionProcedure.execute(entity)) {
				entity.getPersistentData().putDouble("leapTicks", (entity.getPersistentData().getDouble("leapTicks") + 1));
				if (entity.getPersistentData().getDouble("leapTicks") > 11) {
					entity.getPersistentData().putDouble("leapTicks", 0);
					SetActionStateFalseProcedure.execute(entity, 2);
				}
			}
			if (RazorTyrantFirstEncounterPlaybackConditionProcedure.execute(entity)) {
				entity.getPersistentData().putDouble("leapTicks", (entity.getPersistentData().getDouble("leapTicks") + 1));
				if (entity.getPersistentData().getDouble("leapTicks") > 58) {
					entity.getPersistentData().putDouble("leapTicks", 0);
					SetActionStateFalseProcedure.execute(entity, 30);
				}
			}
		}
		if ((entity instanceof RazorTyrantEntity _datEntI ? _datEntI.getEntityData().get(RazorTyrantEntity.DATA_RightArmActionState) : 0) != 0) {
			width = entity.getBbWidth();
			if (RazorTyrantRightSlashPlaybackConditionProcedure.execute(entity)) {
				BasicRightAttackProgressProcedure.execute(world, x, y, z, entity, 18, 7, 0, width, width, width * 2.5, width * 1.5, entity.getYRot(), "rightArmActionProgress1", "rightArmTicks1");
			}
			if (RazorTyrantRightChoppingPlaybackConditionProcedure.execute(entity)) {
				BasicRightAttackProgressProcedure.execute(world, x, y, z, entity, 20, 7, 1, width, width, width * 2.25, width * 0.75, entity.getYRot(), "rightArmActionProgress2", "rightArmTicks2");
			}
			if (RazorTyrantRightLowStabPlayBackConditionProcedure.execute(entity)) {
				BasicRightAttackProgressProcedure.execute(world, x, y, z, entity, 20, 12, 2, width, width, width * 1.625, width * 0.375, entity.getYRot() - 14, "rightArmActionProgress3", "rightArmTicks3");
			}
			if (RazorTyrantRightUpStabPlayBackConditionProcedure.execute(entity)) {
				BasicRightAttackProgressProcedure.execute(world, x, y, z, entity, 19, 9, 3, width, width, width * 3.75, width * 1.9, entity.getYRot(), "rightArmActionProgress4", "rightArmTicks4");
			}
		}
		if ((entity instanceof RazorTyrantEntity _datEntI ? _datEntI.getEntityData().get(RazorTyrantEntity.DATA_LeftArmActionState) : 0) != 0) {
			width = entity.getBbWidth();
			if (RazorTyrantLeftSlashPlaybackConditionProcedure.execute(entity)) {
				BasicLeftAttackProgressProcedure.execute(world, x, y, z, entity, 18, 7, 0, width, width, width * 2.5, width * 1.5, entity.getYRot(), "leftArmActionProgress1", "leftArmTicks1");
			}
			if (RazorTyrantLeftChoppingPlaybackConditionProcedure.execute(entity)) {
				BasicLeftAttackProgressProcedure.execute(world, x, y, z, entity, 20, 7, 1, width, width, width * 2.25, width * 0.75, entity.getYRot(), "leftArmActionProgress2", "leftArmTicks2");
			}
			if (RazorTyrantLeftLowStabPlayBackConditionProcedure.execute(entity)) {
				BasicLeftAttackProgressProcedure.execute(world, x, y, z, entity, 20, 12, 2, width, width, width * 1.625, width * 0.375, entity.getYRot() + 14, "leftArmActionProgress3", "leftArmTicks3");
			}
			if (RazorTyrantLeftUpStabPlayBackConditionProcedure.execute(entity)) {
				BasicLeftAttackProgressProcedure.execute(world, x, y, z, entity, 19, 9, 3, width, width, width * 3.75, width * 1.9, entity.getYRot(), "leftArmActionProgress4", "leftArmTicks4");
			}
		}
	}
}
