package net.mcreator.razortyrant.procedures;

import net.minecraftforge.registries.ForgeRegistries;

import net.minecraft.world.phys.Vec3;
import net.minecraft.world.level.LevelAccessor;
import net.minecraft.world.level.Level;
import net.minecraft.world.level.GameRules;
import net.minecraft.world.entity.projectile.Projectile;
import net.minecraft.world.entity.projectile.AbstractArrow;
import net.minecraft.world.entity.Mob;
import net.minecraft.world.entity.Entity;
import net.minecraft.sounds.SoundSource;
import net.minecraft.server.level.ServerLevel;
import net.minecraft.resources.ResourceLocation;
import net.minecraft.core.BlockPos;
import net.minecraft.commands.arguments.EntityAnchorArgument;

import net.mcreator.razortyrant.init.RazorTyrantModEntities;
import net.mcreator.razortyrant.entity.TyrantProjectileEntity;

public class RazorTyrantActionTriggerProcedure {
	public static void execute(LevelAccessor world, double x, double y, double z, Entity entity) {
		if (entity == null)
			return;
		Entity target = null;
		boolean isCollidedHorizontally = false;
		double distanceFlat = 0;
		double ydiff = 0;
		double random = 0;
		double viewX = 0;
		double viewY = 0;
		double viewZ = 0;
		if (entity.tickCount % 3 == 0) {
			isCollidedHorizontally = entity.horizontalCollision && world.getLevelData().getGameRules().getBoolean(GameRules.RULE_MOBGRIEFING);
			if (!RazorTyrantFirstEncounterPlaybackConditionProcedure.execute(entity) && (isCollidedHorizontally || !((entity instanceof Mob _mobEnt ? (Entity) _mobEnt.getTarget() : null) == null))) {
				target = (entity instanceof Mob _mobEnt ? (Entity) _mobEnt.getTarget() : null) == null ? entity : (entity instanceof Mob _mobEnt ? (Entity) _mobEnt.getTarget() : null);
				ydiff = target.getY() - y;
				distanceFlat = CalculateDistanceFlatProcedure.execute(x + entity.getDeltaMovement().x() * 4, target.getX() + target.getDeltaMovement().x() * 4, z + entity.getDeltaMovement().z() * 4, target.getZ() + target.getDeltaMovement().z() * 4);
				random = Math.random();
				if (distanceFlat <= (entity.getBbWidth() + target.getBbWidth()) * 0.5 + entity.getBbWidth() * 1.5 || isCollidedHorizontally) {
					if (random < 0.1 && !(isCollidedHorizontally || RazorTyrantRightStompPlaybackConditionProcedure.execute(entity)) && ydiff > entity.getBbWidth() * (-0.5) - target.getBbHeight() && ydiff < entity.getBbWidth() * 0.75) {
						if (entity instanceof Mob _entity)
							_entity.getNavigation().stop();
						entity.lookAt(EntityAnchorArgument.Anchor.EYES, new Vec3((target.getX()), (target.getY()), (target.getZ())));
						if (world instanceof Level _level) {
							if (!_level.isClientSide()) {
								_level.playSound(null, BlockPos.containing(x, y + entity.getBbWidth(), z), ForgeRegistries.SOUND_EVENTS.getValue(new ResourceLocation("block.piston.extend")), SoundSource.HOSTILE, (float) 1.5, (float) 0.5);
							} else {
								_level.playLocalSound(x, (y + entity.getBbWidth()), z, ForgeRegistries.SOUND_EVENTS.getValue(new ResourceLocation("block.piston.extend")), SoundSource.HOSTILE, (float) 1.5, (float) 0.5, false);
							}
						}
						SetActionStateTrueProcedure.execute(entity, 0);
					} else if (random < 0.325 && (ydiff > entity.getBbWidth() * 1.5 - target.getBbHeight() && ydiff < entity.getBbWidth() * 2.5 || isCollidedHorizontally)) {
						entity.lookAt(EntityAnchorArgument.Anchor.EYES, new Vec3((target.getX()), (target.getY()), (target.getZ())));
						if (!RazorTyrantRightSlashPlaybackConditionProcedure.execute(entity)) {
							SetRightArmActionStateTrueProcedure.execute(entity, 0);
						} else if (!RazorTyrantLeftSlashPlaybackConditionProcedure.execute(entity)) {
							SetLeftArmActionStateTrueProcedure.execute(entity, 0);
						}
					} else if (random < 0.55 && (ydiff > entity.getBbWidth() * 0.75 - target.getBbHeight() && ydiff < entity.getBbWidth() * 2.25 || isCollidedHorizontally)) {
						entity.lookAt(EntityAnchorArgument.Anchor.EYES, new Vec3((target.getX()), (target.getY()), (target.getZ())));
						if (!RazorTyrantRightChoppingPlaybackConditionProcedure.execute(entity)) {
							SetRightArmActionStateTrueProcedure.execute(entity, 1);
						} else if (!RazorTyrantLeftChoppingPlaybackConditionProcedure.execute(entity)) {
							SetLeftArmActionStateTrueProcedure.execute(entity, 1);
						}
					} else if (random < 0.725 && (ydiff > entity.getBbWidth() * 0.375 - target.getBbHeight() && ydiff < entity.getBbWidth() * 1.625 || isCollidedHorizontally)) {
						entity.lookAt(EntityAnchorArgument.Anchor.EYES, new Vec3((target.getX()), (target.getY()), (target.getZ())));
						if (!RazorTyrantRightLowStabPlayBackConditionProcedure.execute(entity)) {
							SetRightArmActionStateTrueProcedure.execute(entity, 2);
						} else if (!RazorTyrantLeftLowStabPlayBackConditionProcedure.execute(entity)) {
							SetLeftArmActionStateTrueProcedure.execute(entity, 2);
						}
					} else if (random < 1 && (ydiff > entity.getBbWidth() * 2 - target.getBbHeight() && ydiff < entity.getBbWidth() * 3.75 || isCollidedHorizontally)) {
						entity.lookAt(EntityAnchorArgument.Anchor.EYES, new Vec3((target.getX()), (target.getY()), (target.getZ())));
						if (!RazorTyrantRightUpStabPlayBackConditionProcedure.execute(entity)) {
							SetRightArmActionStateTrueProcedure.execute(entity, 3);
						} else if (!RazorTyrantLeftUpStabPlayBackConditionProcedure.execute(entity)) {
							SetLeftArmActionStateTrueProcedure.execute(entity, 3);
						}
					}
				} else if (random > 0.9 && entity.onGround() && !(RazorTyrantLeapPlaybackConditionProcedure.execute(entity) || RazorTyrantRightStompPlaybackConditionProcedure.execute(entity))) {
					entity.lookAt(EntityAnchorArgument.Anchor.EYES, new Vec3((target.getX()), (target.getY()), (target.getZ())));
					entity.push((entity.getLookAngle().x * 2), 0.3, (entity.getLookAngle().z * 2));
					if (world instanceof Level _level) {
						if (!_level.isClientSide()) {
							_level.playSound(null, BlockPos.containing(x, y, z), ForgeRegistries.SOUND_EVENTS.getValue(new ResourceLocation("entity.generic.explode")), SoundSource.HOSTILE, (float) 1.5, 2);
						} else {
							_level.playLocalSound(x, y, z, ForgeRegistries.SOUND_EVENTS.getValue(new ResourceLocation("entity.generic.explode")), SoundSource.HOSTILE, (float) 1.5, 2, false);
						}
					}
					SetActionStateTrueProcedure.execute(entity, 2);
				}
				if (random < 0.2 && !(isCollidedHorizontally || RazorTyrantHeadShootPlaybackConditionProcedure.execute(entity))) {
					entity.lookAt(EntityAnchorArgument.Anchor.EYES, new Vec3((target.getX()), (target.getY()), (target.getZ())));
					distanceFlat = CalculateDistanceProcedure.execute(x, target.getX() + target.getDeltaMovement().x() * 4, y, target.getY(), z, target.getZ() + target.getDeltaMovement().z() * 4);
					viewX = (target.getX() + target.getDeltaMovement().x() * 4) - x;
					viewY = distanceFlat * 0.2 + target.getY() - (y + entity.getBbWidth() * 2.5);
					viewZ = (target.getZ() + target.getDeltaMovement().z() * 4) - z;
					if (world instanceof ServerLevel projectileLevel) {
						Projectile _entityToSpawn = new Object() {
							public Projectile getArrow(Level level, Entity shooter, float damage, int knockback) {
								AbstractArrow entityToSpawn = new TyrantProjectileEntity(RazorTyrantModEntities.TYRANT_PROJECTILE.get(), level);
								entityToSpawn.setOwner(shooter);
								entityToSpawn.setBaseDamage(damage);
								entityToSpawn.setKnockback(knockback);
								entityToSpawn.setSilent(true);
								return entityToSpawn;
							}
						}.getArrow(projectileLevel, entity, 0, 0);
						_entityToSpawn.setPos(x, (y + entity.getBbWidth() * 2.5), z);
						_entityToSpawn.shoot(CalculateVectorXProcedure.execute(viewX, viewY, viewZ), CalculateVectorYProcedure.execute(viewX, viewY, viewZ), CalculateVectorZProcedure.execute(viewX, viewY, viewZ),
								(float) (1 + Math.sqrt(distanceFlat) * 0.2), 5);
						projectileLevel.addFreshEntity(_entityToSpawn);
					}
					if (world instanceof Level _level) {
						if (!_level.isClientSide()) {
							_level.playSound(null, BlockPos.containing(x, y + entity.getBbHeight(), z), ForgeRegistries.SOUND_EVENTS.getValue(new ResourceLocation("entity.firework_rocket.launch")), SoundSource.HOSTILE, (float) 1.5, 2);
						} else {
							_level.playLocalSound(x, (y + entity.getBbHeight()), z, ForgeRegistries.SOUND_EVENTS.getValue(new ResourceLocation("entity.firework_rocket.launch")), SoundSource.HOSTILE, (float) 1.5, 2, false);
						}
					}
					SetActionStateTrueProcedure.execute(entity, 1);
				}
			}
		}
	}
}
